//  The file MSDAspectMatch.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package il.ac.wis.cs.s2a.examples.memoryGame.aspects;

import il.ac.wis.cs.s2a.examples.memoryGame.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectMatch extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int MemoryCard_INST_mc1 = 0;
	static final int MemoryCard_INST_mc2 = 1;
	static final int MemoryPanel_INST_memoryPanel = 2;


	MSDAspectMatch()
	{
		addMinimalEvent(MSDMethods.MemoryPanel_MemoryCard_flipUp);
		setHotCut(2,2,4);
		setHotCut(3,2,5);
		setHotCut(1,1,2);
		setLastCut(3,3,6);
		numberOfLifeLines = 3;
		numberOfInstances = 3;
		numberOfVariables = 0;
	}

	//Pointcuts and advices:
	pointcut MemoryPanel_MemoryCard_flipDown(MemoryPanel memoryPanel, MemoryCard memoryCard):
		call(void MemoryCard.flipDown(..))
		&& target(memoryCard) && this(memoryPanel) ;

	after(MemoryPanel memoryPanel,MemoryCard memoryCard):MemoryPanel_MemoryCard_flipDown(memoryPanel,memoryCard)
	{
		changeCutState(MSDMethods.MemoryPanel_MemoryCard_flipDown,
					memoryPanel,memoryCard,null);
	}

	pointcut MemoryPanel_MemoryPanel_soundBeep(MemoryPanel memoryPanel):
		execution(void MemoryPanel.soundBeep(..))
		&& target(memoryPanel) ;

	after(MemoryPanel memoryPanel):MemoryPanel_MemoryPanel_soundBeep(memoryPanel)
	{
		changeCutState(MSDMethods.MemoryPanel_MemoryPanel_soundBeep,
					memoryPanel,memoryPanel,null);
	}

	pointcut MemoryPanel_MemoryCard_flipUp(MemoryPanel memoryPanel, MemoryCard memoryCard):
		call(void MemoryCard.flipUp(..))
		&& target(memoryCard) && this(memoryPanel) ;

	after(MemoryPanel memoryPanel,MemoryCard memoryCard):MemoryPanel_MemoryCard_flipUp(memoryPanel,memoryCard)
	{
		changeCutState(MSDMethods.MemoryPanel_MemoryCard_flipUp,
					memoryPanel,memoryCard,null);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.MemoryPanel_MemoryCard_flipDown:
				if(activeMSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMSD.instancesEquals(MemoryCard_INST_mc1,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,2,4))
					{
						activeMSD.setCut(3,2,5);
						return;
					}
				}
				if(activeMSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMSD.instancesEquals(MemoryCard_INST_mc2,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(3,2,5))
					{
						activeMSD.setCut(3,3,6);
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.MemoryPanel_MemoryPanel_soundBeep:
				if(activeMSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMSD.instancesEquals(MemoryPanel_INST_memoryPanel,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,1,2))
					{
						activeMSD.setCut(1,1,3);
						if(evaluateCondition(3,activeMSD))
						{
							activeMSD.setCut(2,2,4);
							return;
						}
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.MemoryPanel_MemoryCard_flipUp:
				if(activeMSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMSD.instancesEquals(MemoryCard_INST_mc1,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,0))
					{
						activeMSD.setLineInstance(MemoryCard_INST_mc1,targetObject);
						activeMSD.setCut(1,0,1);
						return;
					}
				}
				if(activeMSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMSD.instancesEquals(MemoryCard_INST_mc2,null))
				{
					unification=true;
					if(activeMSD.isInCut(1,0,1))
					{
						activeMSD.setLineInstance(MemoryCard_INST_mc2,targetObject);
						activeMSD.setCut(1,1,2);
						return;
					}
				}
				if(activeMSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMSD.instancesEquals(MemoryCard_INST_mc1,targetObject))
				{
					unification=true;
				}
				if(activeMSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMSD.instancesEquals(MemoryCard_INST_mc2,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		MemoryCard mc1 = (MemoryCard)activeMSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryCard mc2 = (MemoryCard)activeMSD.getLineInstance(MemoryCard_INST_mc2);
		MemoryPanel memoryPanel = (MemoryPanel)activeMSD.getLineInstance(MemoryPanel_INST_memoryPanel);

		switch (conditionNumber)
		{
			case 3: 
				return !mc1.match(mc2);
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		activeMSD.setLineInstance(MemoryPanel_INST_memoryPanel,MSDEnv.getLifeLineInstance("MemoryPanel"));
		MemoryCard mc1 = (MemoryCard)activeMSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryCard mc2 = (MemoryCard)activeMSD.getLineInstance(MemoryCard_INST_mc2);
		MemoryPanel memoryPanel = (MemoryPanel)activeMSD.getLineInstance(MemoryPanel_INST_memoryPanel);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		MemoryCard mc1 = (MemoryCard)activeMSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryCard mc2 = (MemoryCard)activeMSD.getLineInstance(MemoryCard_INST_mc2);
		MemoryPanel memoryPanel = (MemoryPanel)activeMSD.getLineInstance(MemoryPanel_INST_memoryPanel);

		MSDMethod MSDm3 = new MSDMethod(memoryPanel,memoryPanel,
			MSDMethods.MemoryPanel_MemoryPanel_soundBeep,null);// soundBeep() Execute
		MSDMethod MSDm4 = new MSDMethod(memoryPanel,mc1,
			MSDMethods.MemoryPanel_MemoryCard_flipUp,null);// flipUp() Monitored
		MSDMethod MSDm5 = new MSDMethod(memoryPanel,mc2,
			MSDMethods.MemoryPanel_MemoryCard_flipUp,null);// flipUp() Monitored
		MSDMethod MSDm6 = new MSDMethod(memoryPanel,mc1,
			MSDMethods.MemoryPanel_MemoryCard_flipDown,null);// flipDown() Execute
		MSDMethod MSDm7 = new MSDMethod(memoryPanel,mc2,
			MSDMethods.MemoryPanel_MemoryCard_flipDown,null);// flipDown() Execute

		 if(activeMSD.isInCut(0,0,0))
		{
				ME.add(MSDm4);
				CV.add(MSDm6,MSDm7,MSDm3);
				return;
		}
		 if(activeMSD.isInCut(1,0,1))
		{
				ME.add(MSDm5);
				CV.add(MSDm6,MSDm7,MSDm3);
				return;
		}
		 if(activeMSD.isInCut(1,1,2))
		{
				EE.add(MSDm3);
				HV.add(MSDm6,MSDm4,MSDm5,MSDm7);
				return;
		}
		 if(activeMSD.isInCut(2,2,4))
		{
				EE.add(MSDm6);
				HV.add(MSDm4,MSDm5,MSDm3);
				return;
		}
		 if(activeMSD.isInCut(3,2,5))
		{
				EE.add(MSDm7);
				HV.add(MSDm4,MSDm5,MSDm3);
				return;
		}
	}
}
