//  The file MSDAspectGhostEaten.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package pacman.aspects;

import pacman.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectGhostEaten extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int Player_INST_player = 0;
	static final int Ghost_INST_ghost = 1;
	static final int GameModel_INST_gameModel = 2;

	static final int boolean_arg_exact_eyes0 = 0;
	static final int boolean_arg_exact_eyes2 = 1;

	MSDAspectGhostEaten()
	{
		addMinimalEvent(MSDMethods.Player_Ghost_eatenByPacman);
		setHotCut(2,4,2);
		setHotCut(2,6,2);
		setHotCut(1,2,1);
		setLastCut(2,8,3);
		numberOfLifeLines = 3;
		numberOfInstances = 3;
		numberOfVariables = 2;
	}

	//Pointcuts and advices:
	pointcut Ghost_Ghost_setEyesOnly(Ghost ghost,boolean exact_eyes2):
		execution(void Ghost.setEyesOnly(..))
		&& target(ghost)  && args(exact_eyes2);

	after(Ghost ghost,boolean exact_eyes2):Ghost_Ghost_setEyesOnly(ghost, exact_eyes2)
	{
		ArrayList<Object> args = getArgsList(exact_eyes2);
		changeCutState(MSDMethods.Ghost_Ghost_setEyesOnly,
					ghost,ghost,args);
	}

	pointcut Ghost_GameModel_enteringJail(Ghost ghost, GameModel gameModel):
		call(void GameModel.enteringJail(..))
		&& target(gameModel) && this(ghost) ;

	after(Ghost ghost,GameModel gameModel):Ghost_GameModel_enteringJail(ghost,gameModel)
	{
		changeCutState(MSDMethods.Ghost_GameModel_enteringJail,
					ghost,gameModel,null);
	}

	pointcut Ghost_GameModel_getGhostScore(Ghost ghost, GameModel gameModel):
		call(int GameModel.getGhostScore(..))
		&& target(gameModel) && this(ghost) ;

	after(Ghost ghost,GameModel gameModel):Ghost_GameModel_getGhostScore(ghost,gameModel)
	{
		changeCutState(MSDMethods.Ghost_GameModel_getGhostScore,
					ghost,gameModel,null);
	}

	pointcut Ghost_Player_increaseScore(Ghost ghost, Player player):
		call(void Player.increaseScore(..))
		&& target(player) && this(ghost) ;

	after(Ghost ghost,Player player):Ghost_Player_increaseScore(ghost,player)
	{
		changeCutState(MSDMethods.Ghost_Player_increaseScore,
					ghost,player,null);
	}

	pointcut Ghost_Ghost_goToJail(Ghost ghost):
		execution(void Ghost.goToJail(..))
		&& target(ghost) ;

	after(Ghost ghost):Ghost_Ghost_goToJail(ghost)
	{
		changeCutState(MSDMethods.Ghost_Ghost_goToJail,
					ghost,ghost,null);
	}

	pointcut Ghost_GameModel_doubleGhostScore(Ghost ghost, GameModel gameModel):
		call(void GameModel.doubleGhostScore(..))
		&& target(gameModel) && this(ghost) ;

	after(Ghost ghost,GameModel gameModel):Ghost_GameModel_doubleGhostScore(ghost,gameModel)
	{
		changeCutState(MSDMethods.Ghost_GameModel_doubleGhostScore,
					ghost,gameModel,null);
	}

	pointcut Player_Ghost_eatenByPacman(Player player, Ghost ghost):
		call(void Ghost.eatenByPacman(..))
		&& target(ghost) && this(player) ;

	after(Player player,Ghost ghost):Player_Ghost_eatenByPacman(player,ghost)
	{
		changeCutState(MSDMethods.Player_Ghost_eatenByPacman,
					player,ghost,null);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.Ghost_Ghost_setEyesOnly:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject)
					&& activeMSD.variableEquals(boolean_arg_exact_eyes0,args.get(0)))
				{
					unification=true;
					if(activeMSD.isInCut(2,4,2))
					{
						activeMSD.setCut(2,5,2);
						return;
					}
				}
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject)
					&& activeMSD.variableEquals(boolean_arg_exact_eyes2,args.get(0)))
				{
					unification=true;
					if(activeMSD.isInCut(2,7,3))
					{
						activeMSD.setCut(2,8,3);
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_GameModel_enteringJail:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,6,2))
					{
						activeMSD.setCut(2,7,3);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_GameModel_getGhostScore:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,null))
				{
					unification=true;
					if(activeMSD.isInCut(1,1,0))
					{
						activeMSD.setLineInstance(GameModel_INST_gameModel,targetObject);
						activeMSD.setCut(1,2,1);
						return;
					}
				}
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Player_increaseScore:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,2,1))
					{
						activeMSD.setCut(2,3,1);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Ghost_goToJail:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,5,2))
					{
						activeMSD.setCut(2,6,2);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_GameModel_doubleGhostScore:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,3,1))
					{
						activeMSD.setCut(2,4,2);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Player_Ghost_eatenByPacman:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,null)
					&& activeMSD.instancesEquals(Player_INST_player,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,0))
					{
						activeMSD.setLineInstance(Ghost_INST_ghost,targetObject);
						activeMSD.setLineInstance(Player_INST_player,sourceObject);
						activeMSD.setCut(1,1,0);
						return;
					}
				}
				if(activeMSD.instancesEquals(Player_INST_player,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		Boolean eyes2 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_eyes2);
		Boolean eyes0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_eyes0);

		switch (conditionNumber)
		{
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		activeMSD.setPrivateVariable(boolean_arg_exact_eyes0,true);
		activeMSD.setPrivateVariable(boolean_arg_exact_eyes2,false);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		Boolean eyes2 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_eyes2);
		Boolean eyes0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_eyes0);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		Boolean VAR_exact_eyes2 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_eyes2);
		Boolean VAR_exact_eyes0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_eyes0);

		MSDMethod MSDm59 = new MSDMethod(player,ghost,
			MSDMethods.Player_Ghost_eatenByPacman,null);// eatenByPacman() Monitored
		MSDMethod MSDm60 = new MSDMethod(ghost,player,
			MSDMethods.Ghost_Player_increaseScore,null);// increaseScore() Monitored
		MSDMethod MSDm61 = new MSDMethod(ghost,gameModel,
			MSDMethods.Ghost_GameModel_doubleGhostScore,null);// doubleGhostScore() Monitored
		ArrayList<Object>  args62 = getArgsList(VAR_exact_eyes0);
		MSDMethod MSDm62 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_setEyesOnly,args62);// setEyesOnly() Monitored
		ArrayList<Object>  args63 = getArgsList(VAR_exact_eyes2);
		MSDMethod MSDm63 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_setEyesOnly,args63);// setEyesOnly() Monitored
		MSDMethod MSDm64 = new MSDMethod(ghost,gameModel,
			MSDMethods.Ghost_GameModel_getGhostScore,null);// getGhostScore() Monitored
		MSDMethod MSDm65 = new MSDMethod(ghost,gameModel,
			MSDMethods.Ghost_GameModel_enteringJail,null);// enteringJail() Monitored
		MSDMethod MSDm66 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_goToJail,null);// goToJail() Monitored

		 if(activeMSD.isInCut(0,0,0))
		{
				ME.add(MSDm59);
				CV.add(MSDm61,MSDm64,MSDm63,MSDm62,MSDm66,MSDm65,MSDm60);
				return;
		}
		 if(activeMSD.isInCut(1,1,0))
		{
				ME.add(MSDm64);
				CV.add(MSDm61,MSDm59,MSDm63,MSDm62,MSDm66,MSDm65,MSDm60);
				return;
		}
		 if(activeMSD.isInCut(1,2,1))
		{
				ME.add(MSDm60);
				HV.add(MSDm61,MSDm59,MSDm64,MSDm63,MSDm62,MSDm66,MSDm65);
				return;
		}
		 if(activeMSD.isInCut(2,3,1))
		{
				ME.add(MSDm61);
				CV.add(MSDm59,MSDm64,MSDm63,MSDm62,MSDm66,MSDm65,MSDm60);
				return;
		}
		 if(activeMSD.isInCut(2,4,2))
		{
				ME.add(MSDm62);
				HV.add(MSDm61,MSDm59,MSDm64,MSDm66,MSDm65,MSDm60);
				return;
		}
		 if(activeMSD.isInCut(2,5,2))
		{
				ME.add(MSDm66);
				CV.add(MSDm61,MSDm59,MSDm64,MSDm63,MSDm62,MSDm65,MSDm60);
				return;
		}
		 if(activeMSD.isInCut(2,6,2))
		{
				ME.add(MSDm65);
				HV.add(MSDm61,MSDm59,MSDm64,MSDm63,MSDm62,MSDm66,MSDm60);
				return;
		}
		 if(activeMSD.isInCut(2,7,3))
		{
				ME.add(MSDm63);
				CV.add(MSDm61,MSDm59,MSDm64,MSDm66,MSDm65,MSDm60);
				return;
		}
	}
}
