//  The file MSDAspectGhostEatsPacman.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package pacman.aspects;

import pacman.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectGhostEatsPacman extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int GameModel_INST_gameModel = 0;
	static final int GameControl_INST_gameControl = 1;
	static final int Ghost_INST_ghost = 2;
	static final int Player_INST_player = 3;

	static final int boolean_arg_exact_paused0 = 0;

	MSDAspectGhostEatsPacman()
	{
		addMinimalEvent(MSDMethods.GameControl_Ghost_collidedWithPacman);
		setHotCut(1,4,4,3);
		setHotCut(0,2,3,0);
		setHotCut(0,3,4,3);
		setHotCut(0,2,4,2);
		setHotCut(0,2,4,1);
		setHotCut(5,7,4,4);
		setHotCut(4,6,4,4);
		setHotCut(0,1,2,0);
		setHotCut(2,4,4,3);
		setLastCut(5,8,4,5);
		numberOfLifeLines = 4;
		numberOfInstances = 4;
		numberOfVariables = 1;
	}

	//Pointcuts and advices:
	pointcut GameControl_GameModel_restartGame(GameControl gameControl, GameModel gameModel):
		call(void GameModel.restartGame(..))
		&& target(gameModel) && this(gameControl) ;

	after(GameControl gameControl,GameModel gameModel):GameControl_GameModel_restartGame(gameControl,gameModel)
	{
		changeCutState(MSDMethods.GameControl_GameModel_restartGame,
					gameControl,gameModel,null);
	}

	pointcut Ghost_Player_eatenByGhost(Ghost ghost, Player player):
		call(void Player.eatenByGhost(..))
		&& target(player) && this(ghost) ;

	after(Ghost ghost,Player player):Ghost_Player_eatenByGhost(ghost,player)
	{
		changeCutState(MSDMethods.Ghost_Player_eatenByGhost,
					ghost,player,null);
	}

	pointcut GameControl_GameModel_pacmanWasEaten(GameControl gameControl, GameModel gameModel):
		call(void GameModel.pacmanWasEaten(..))
		&& target(gameModel) && this(gameControl) ;

	after(GameControl gameControl,GameModel gameModel):GameControl_GameModel_pacmanWasEaten(gameControl,gameModel)
	{
		changeCutState(MSDMethods.GameControl_GameModel_pacmanWasEaten,
					gameControl,gameModel,null);
	}

	pointcut GameControl_Ghost_collidedWithPacman(GameControl gameControl, Ghost ghost):
		call(void Ghost.collidedWithPacman(..))
		&& target(ghost) && this(gameControl) ;

	after(GameControl gameControl,Ghost ghost):GameControl_Ghost_collidedWithPacman(gameControl,ghost)
	{
		changeCutState(MSDMethods.GameControl_Ghost_collidedWithPacman,
					gameControl,ghost,null);
	}

	pointcut Player_GameControl_playerEaten(Player player, GameControl gameControl):
		call(void GameControl.playerEaten(..))
		&& target(gameControl) && this(player) ;

	after(Player player,GameControl gameControl):Player_GameControl_playerEaten(player,gameControl)
	{
		changeCutState(MSDMethods.Player_GameControl_playerEaten,
					player,gameControl,null);
	}

	pointcut GameControl_Ghost_eatPacman(GameControl gameControl, Ghost ghost):
		call(void Ghost.eatPacman(..))
		&& target(ghost) && this(gameControl) ;

	after(GameControl gameControl,Ghost ghost):GameControl_Ghost_eatPacman(gameControl,ghost)
	{
		changeCutState(MSDMethods.GameControl_Ghost_eatPacman,
					gameControl,ghost,null);
	}

	pointcut GameControl_Player_decreaseLivesNumber(GameControl gameControl, Player player):
		call(void Player.decreaseLivesNumber(..))
		&& target(player) && this(gameControl) ;

	after(GameControl gameControl,Player player):GameControl_Player_decreaseLivesNumber(gameControl,player)
	{
		changeCutState(MSDMethods.GameControl_Player_decreaseLivesNumber,
					gameControl,player,null);
	}

	pointcut GameControl_GameModel_setPausedGame(GameControl gameControl, GameModel gameModel,boolean exact_paused0):
		call(void GameModel.setPausedGame(..))
		&& target(gameModel) && this(gameControl)  && args(exact_paused0);

	after(GameControl gameControl,GameModel gameModel,boolean exact_paused0):GameControl_GameModel_setPausedGame(gameControl,gameModel, exact_paused0)
	{
		ArrayList<Object> args = getArgsList(exact_paused0);
		changeCutState(MSDMethods.GameControl_GameModel_setPausedGame,
					gameControl,gameModel,args);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.GameControl_GameModel_restartGame:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(4,6,4,4))
					{
						activeMSD.setCut(5,7,4,4);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Player_eatenByGhost:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,2,3,0))
					{
						activeMSD.setLineInstance(Player_INST_player,targetObject);
						activeMSD.setCut(0,2,4,1);
						if(evaluateCondition(2,activeMSD))
						{
							activeMSD.setCut(0,2,4,2);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_GameModel_pacmanWasEaten:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,3,4,3))
					{
						activeMSD.setLineInstance(GameModel_INST_gameModel,targetObject);
						activeMSD.setCut(1,4,4,3);
						if(evaluateCondition(4,activeMSD))
						{
							activeMSD.setCut(2,4,4,3);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_Ghost_collidedWithPacman:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,null)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,0,0))
					{
						activeMSD.setLineInstance(Ghost_INST_ghost,targetObject);
						activeMSD.setLineInstance(GameControl_INST_gameControl,sourceObject);
						activeMSD.setCut(0,1,1,0);
						if(evaluateCondition(6,activeMSD))
						{
							activeMSD.setCut(0,1,2,0);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Player_GameControl_playerEaten:
				if(activeMSD.instancesEquals(Player_INST_player,sourceObject)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(0,2,4,2))
					{
						activeMSD.setCut(0,3,4,3);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_Ghost_eatPacman:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(0,1,2,0))
					{
						activeMSD.setCut(0,2,3,0);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_Player_decreaseLivesNumber:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(5,7,4,4))
					{
						activeMSD.setCut(5,8,4,5);
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_GameModel_setPausedGame:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject)
					&& activeMSD.variableEquals(boolean_arg_exact_paused0,args.get(0)))
				{
					unification=true;
					if(activeMSD.isInCut(2,4,4,3))
					{
						activeMSD.setCut(3,5,4,3);
						if(evaluateCondition(11,activeMSD))
						{
							activeMSD.setCut(4,6,4,4);
							return;
						}
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		Boolean paused0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_paused0);

		switch (conditionNumber)
		{
			case 2: 
				return player.m_direction == Thing.STILL;
			case 4: 
				return gameModel.m_state == GameModel.STATE_DEAD_PLAY;
			case 6: 
				return ghost.isEatingPacman();
			case 11: 
				return player.livesNumber>0;
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		activeMSD.setPrivateVariable(boolean_arg_exact_paused0,true);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		Boolean paused0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_paused0);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		Boolean VAR_exact_paused0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_paused0);

		MSDMethod MSDm7 = new MSDMethod(gameControl,ghost,
			MSDMethods.GameControl_Ghost_collidedWithPacman,null);// collidedWithPacman() Monitored
		MSDMethod MSDm8 = new MSDMethod(player,gameControl,
			MSDMethods.Player_GameControl_playerEaten,null);// playerEaten() Monitored
		MSDMethod MSDm9 = new MSDMethod(ghost,player,
			MSDMethods.Ghost_Player_eatenByGhost,null);// eatenByGhost() Monitored
		MSDMethod MSDm10 = new MSDMethod(gameControl,ghost,
			MSDMethods.GameControl_Ghost_eatPacman,null);// eatPacman() Monitored
		MSDMethod MSDm11 = new MSDMethod(gameControl,gameModel,
			MSDMethods.GameControl_GameModel_pacmanWasEaten,null);// pacmanWasEaten() Monitored
		MSDMethod MSDm12 = new MSDMethod(gameControl,gameModel,
			MSDMethods.GameControl_GameModel_restartGame,null);// restartGame() Monitored
		MSDMethod MSDm13 = new MSDMethod(gameControl,player,
			MSDMethods.GameControl_Player_decreaseLivesNumber,null);// decreaseLivesNumber() Monitored
		ArrayList<Object>  args14 = getArgsList(VAR_exact_paused0);
		MSDMethod MSDm14 = new MSDMethod(gameControl,gameModel,
			MSDMethods.GameControl_GameModel_setPausedGame,args14);// setPausedGame() Monitored

		 if(activeMSD.isInCut(0,0,0,0))
		{
				ME.add(MSDm7);
				CV.add(MSDm12,MSDm11,MSDm13,MSDm9,MSDm8,MSDm14,MSDm10);
				return;
		}
		 if(activeMSD.isInCut(0,1,2,0))
		{
				ME.add(MSDm10);
				HV.add(MSDm12,MSDm11,MSDm13,MSDm9,MSDm8,MSDm7,MSDm14);
				return;
		}
		 if(activeMSD.isInCut(0,2,3,0))
		{
				ME.add(MSDm9);
				HV.add(MSDm12,MSDm11,MSDm13,MSDm8,MSDm7,MSDm14,MSDm10);
				return;
		}
		 if(activeMSD.isInCut(0,2,4,2))
		{
				ME.add(MSDm8);
				HV.add(MSDm12,MSDm11,MSDm13,MSDm9,MSDm7,MSDm14,MSDm10);
				return;
		}
		 if(activeMSD.isInCut(0,3,4,3))
		{
				ME.add(MSDm11);
				HV.add(MSDm12,MSDm13,MSDm9,MSDm8,MSDm7,MSDm14,MSDm10);
				return;
		}
		 if(activeMSD.isInCut(2,4,4,3))
		{
				ME.add(MSDm14);
				HV.add(MSDm12,MSDm11,MSDm13,MSDm9,MSDm8,MSDm7,MSDm10);
				return;
		}
		 if(activeMSD.isInCut(4,6,4,4))
		{
				ME.add(MSDm12);
				HV.add(MSDm11,MSDm13,MSDm9,MSDm8,MSDm7,MSDm14,MSDm10);
				return;
		}
		 if(activeMSD.isInCut(5,7,4,4))
		{
				ME.add(MSDm13);
				HV.add(MSDm12,MSDm11,MSDm9,MSDm8,MSDm7,MSDm14,MSDm10);
				return;
		}
	}
}
