//  The file MSDAspectGhostFleeing.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package pacman.aspects;

import pacman.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectGhostFleeing extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int GameControl_INST_gameControl = 0;
	static final int Ghost_INST_ghost = 1;


	MSDAspectGhostFleeing()
	{
		addMinimalEvent(MSDMethods.GameControl_Ghost_pacmanAtePowerup);
		setHotCut(1,3);
		setHotCut(1,2);
		setHotCut(2,5);
		setLastCut(3,6);
		numberOfLifeLines = 2;
		numberOfInstances = 2;
		numberOfVariables = 0;
	}

	//Pointcuts and advices:
	pointcut Ghost_GameControl_ghostSlowedDown(Ghost ghost, GameControl gameControl):
		call(void GameControl.ghostSlowedDown(..))
		&& target(gameControl) && this(ghost) ;

	after(Ghost ghost,GameControl gameControl):Ghost_GameControl_ghostSlowedDown(ghost,gameControl)
	{
		changeCutState(MSDMethods.Ghost_GameControl_ghostSlowedDown,
					ghost,gameControl,null);
	}

	pointcut Ghost_Ghost_stopFleeing(Ghost ghost):
		execution(void Ghost.stopFleeing(..))
		&& target(ghost) ;

	after(Ghost ghost):Ghost_Ghost_stopFleeing(ghost)
	{
		changeCutState(MSDMethods.Ghost_Ghost_stopFleeing,
					ghost,ghost,null);
	}

	pointcut Ghost_Ghost_slowDown(Ghost ghost):
		execution(void Ghost.slowDown(..))
		&& target(ghost) ;

	after(Ghost ghost):Ghost_Ghost_slowDown(ghost)
	{
		changeCutState(MSDMethods.Ghost_Ghost_slowDown,
					ghost,ghost,null);
	}

	pointcut Ghost_GameControl_ghostStoppedFleeing(Ghost ghost, GameControl gameControl):
		call(void GameControl.ghostStoppedFleeing(..))
		&& target(gameControl) && this(ghost) ;

	after(Ghost ghost,GameControl gameControl):Ghost_GameControl_ghostStoppedFleeing(ghost,gameControl)
	{
		changeCutState(MSDMethods.Ghost_GameControl_ghostStoppedFleeing,
					ghost,gameControl,null);
	}

	pointcut GameControl_Ghost_pacmanAtePowerup(GameControl gameControl, Ghost ghost):
		call(void Ghost.pacmanAtePowerup(..))
		&& target(ghost) && this(gameControl) ;

	after(GameControl gameControl,Ghost ghost):GameControl_Ghost_pacmanAtePowerup(gameControl,ghost)
	{
		changeCutState(MSDMethods.GameControl_Ghost_pacmanAtePowerup,
					gameControl,ghost,null);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.Ghost_GameControl_ghostSlowedDown:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,3))
					{
						activeMSD.setCut(2,4);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Ghost_stopFleeing:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,4))
					{
						activeMSD.setCut(2,5);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Ghost_slowDown:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,2))
					{
						activeMSD.setCut(1,3);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_GameControl_ghostStoppedFleeing:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,5))
					{
						activeMSD.setCut(3,6);
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_Ghost_pacmanAtePowerup:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,null)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0))
					{
						activeMSD.setLineInstance(Ghost_INST_ghost,targetObject);
						activeMSD.setLineInstance(GameControl_INST_gameControl,sourceObject);
						activeMSD.setCut(1,1);
						if(evaluateCondition(5,activeMSD))
						{
							activeMSD.setCut(1,2);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);

		switch (conditionNumber)
		{
			case 5: 
				return ghost.state!=Ghost.EATEN;
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);

		MSDMethod MSDm48 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_slowDown,null);// slowDown() Monitored
		MSDMethod MSDm49 = new MSDMethod(gameControl,ghost,
			MSDMethods.GameControl_Ghost_pacmanAtePowerup,null);// pacmanAtePowerup() Monitored
		MSDMethod MSDm50 = new MSDMethod(ghost,gameControl,
			MSDMethods.Ghost_GameControl_ghostStoppedFleeing,null);// ghostStoppedFleeing() Monitored
		MSDMethod MSDm51 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_stopFleeing,null);// stopFleeing() Monitored
		MSDMethod MSDm52 = new MSDMethod(ghost,gameControl,
			MSDMethods.Ghost_GameControl_ghostSlowedDown,null);// ghostSlowedDown() Monitored

		 if(activeMSD.isInCut(0,0))
		{
				ME.add(MSDm49);
				CV.add(MSDm52,MSDm48,MSDm50,MSDm51);
				return;
		}
		 if(activeMSD.isInCut(1,2))
		{
				ME.add(MSDm48);
				HV.add(MSDm52,MSDm49,MSDm50,MSDm51);
				return;
		}
		 if(activeMSD.isInCut(1,3))
		{
				ME.add(MSDm52);
				HV.add(MSDm49,MSDm48,MSDm50,MSDm51);
				return;
		}
		 if(activeMSD.isInCut(2,4))
		{
				ME.add(MSDm51);
				CV.add(MSDm52,MSDm49,MSDm48,MSDm50);
				return;
		}
		 if(activeMSD.isInCut(2,5))
		{
				ME.add(MSDm50);
				HV.add(MSDm52,MSDm49,MSDm48,MSDm51);
				return;
		}
	}
}
