//  The file MSDAspectLevelComplete.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package pacman.aspects;

import pacman.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectLevelComplete extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int GameModel_INST_gameModel = 0;
	static final int GameControl_INST_gameControl = 1;
	static final int GameUI_INST_gameUI = 2;

	static final int boolean_arg_exact_redraw0 = 0;
	static final int boolean_arg_exact_vis2 = 1;

	MSDAspectLevelComplete()
	{
		addMinimalEvent(MSDMethods.GameControl_GameModel_levelComplete);
		setHotCut(2,2,1);
		setHotCut(2,2,2);
		setHotCut(4,4,2);
		setHotCut(2,1,0);
		setHotCut(3,3,2);
		setHotCut(1,1,0);
		setLastCut(5,4,2);
		numberOfLifeLines = 3;
		numberOfInstances = 3;
		numberOfVariables = 2;
	}

	//Pointcuts and advices:
	pointcut GameControl_GameModel_loadNextLevel(GameControl gameControl, GameModel gameModel):
		call(void GameModel.loadNextLevel(..))
		&& target(gameModel) && this(gameControl) ;

	after(GameControl gameControl,GameModel gameModel):GameControl_GameModel_loadNextLevel(gameControl,gameModel)
	{
		changeCutState(MSDMethods.GameControl_GameModel_loadNextLevel,
					gameControl,gameModel,null);
	}

	pointcut GameControl_GameModel_setVisibleThings(GameControl gameControl, GameModel gameModel,boolean exact_vis2):
		call(void GameModel.setVisibleThings(..))
		&& target(gameModel) && this(gameControl)  && args(exact_vis2);

	after(GameControl gameControl,GameModel gameModel,boolean exact_vis2):GameControl_GameModel_setVisibleThings(gameControl,gameModel, exact_vis2)
	{
		ArrayList<Object> args = getArgsList(exact_vis2);
		changeCutState(MSDMethods.GameControl_GameModel_setVisibleThings,
					gameControl,gameModel,args);
	}

	pointcut GameControl_GameModel_levelComplete(GameControl gameControl, GameModel gameModel):
		call(void GameModel.levelComplete(..))
		&& target(gameModel) && this(gameControl) ;

	after(GameControl gameControl,GameModel gameModel):GameControl_GameModel_levelComplete(gameControl,gameModel)
	{
		changeCutState(MSDMethods.GameControl_GameModel_levelComplete,
					gameControl,gameModel,null);
	}

	pointcut GameControl_GameUI_setRedraw(GameControl gameControl, GameUI gameUI,boolean exact_redraw0):
		call(void GameUI.setRedraw(..))
		&& target(gameUI) && this(gameControl)  && args(exact_redraw0);

	after(GameControl gameControl,GameUI gameUI,boolean exact_redraw0):GameControl_GameUI_setRedraw(gameControl,gameUI, exact_redraw0)
	{
		ArrayList<Object> args = getArgsList(exact_redraw0);
		changeCutState(MSDMethods.GameControl_GameUI_setRedraw,
					gameControl,gameUI,args);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.GameControl_GameModel_loadNextLevel:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(3,3,2))
					{
						activeMSD.setCut(4,4,2);
						if(evaluateCondition(1,activeMSD))
						{
							activeMSD.setCut(5,4,2);
							break;
						}
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_GameModel_setVisibleThings:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject)
					&& activeMSD.variableEquals(boolean_arg_exact_vis2,args.get(0)))
				{
					unification=true;
					if(activeMSD.isInCut(2,2,2))
					{
						activeMSD.setCut(3,3,2);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_GameModel_levelComplete:
				if(activeMSD.instancesEquals(GameModel_INST_gameModel,null)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,0))
					{
						activeMSD.setLineInstance(GameModel_INST_gameModel,targetObject);
						activeMSD.setLineInstance(GameControl_INST_gameControl,sourceObject);
						activeMSD.setCut(1,1,0);
						if(evaluateCondition(4,activeMSD))
						{
							activeMSD.setCut(2,1,0);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_GameUI_setRedraw:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameUI_INST_gameUI,null)
					&& activeMSD.variableEquals(boolean_arg_exact_redraw0,args.get(0)))
				{
					unification=true;
					if(activeMSD.isInCut(2,1,0))
					{
						activeMSD.setLineInstance(GameUI_INST_gameUI,targetObject);
						activeMSD.setCut(2,2,1);
						if(evaluateCondition(6,activeMSD))
						{
							activeMSD.setCut(2,2,2);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameUI_INST_gameUI,targetObject)
					&& activeMSD.variableEquals(boolean_arg_exact_redraw0,args.get(0)))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		GameUI gameUI = (GameUI)activeMSD.getLineInstance(GameUI_INST_gameUI);
		Boolean vis2 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_vis2);
		Boolean redraw0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_redraw0);

		switch (conditionNumber)
		{
			case 1: 
				return gameModel.m_state == GameModel.STATE_BEGIN_PLAY;
			case 4: 
				return gameModel.m_state == GameModel.STATE_LEVELCOMPLETE;
			case 6: 
				return gameUI.m_bRedrawAll == true;
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		activeMSD.setPrivateVariable(boolean_arg_exact_redraw0,true);
		activeMSD.setPrivateVariable(boolean_arg_exact_vis2,false);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		GameUI gameUI = (GameUI)activeMSD.getLineInstance(GameUI_INST_gameUI);
		Boolean vis2 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_vis2);
		Boolean redraw0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_redraw0);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		GameUI gameUI = (GameUI)activeMSD.getLineInstance(GameUI_INST_gameUI);
		Boolean VAR_exact_vis2 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_vis2);
		Boolean VAR_exact_redraw0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_redraw0);

		ArrayList<Object>  args25 = getArgsList(VAR_exact_redraw0);
		MSDMethod MSDm25 = new MSDMethod(gameControl,gameUI,
			MSDMethods.GameControl_GameUI_setRedraw,args25);// setRedraw() Monitored
		MSDMethod MSDm26 = new MSDMethod(gameControl,gameModel,
			MSDMethods.GameControl_GameModel_levelComplete,null);// levelComplete() Monitored
		MSDMethod MSDm27 = new MSDMethod(gameControl,gameModel,
			MSDMethods.GameControl_GameModel_loadNextLevel,null);// loadNextLevel() Monitored
		ArrayList<Object>  args28 = getArgsList(VAR_exact_vis2);
		MSDMethod MSDm28 = new MSDMethod(gameControl,gameModel,
			MSDMethods.GameControl_GameModel_setVisibleThings,args28);// setVisibleThings() Monitored

		 if(activeMSD.isInCut(0,0,0))
		{
				ME.add(MSDm26);
				CV.add(MSDm25,MSDm28,MSDm27);
				return;
		}
		 if(activeMSD.isInCut(2,1,0))
		{
				ME.add(MSDm25);
				HV.add(MSDm26,MSDm28,MSDm27);
				return;
		}
		 if(activeMSD.isInCut(2,2,2))
		{
				ME.add(MSDm28);
				HV.add(MSDm26,MSDm25,MSDm27);
				return;
		}
		 if(activeMSD.isInCut(3,3,2))
		{
				ME.add(MSDm27);
				HV.add(MSDm26,MSDm25,MSDm28);
				return;
		}
	}
}
