//  The file MSDAspectPacmanEatsGhost.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package pacman.aspects;

import pacman.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectPacmanEatsGhost extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int GameControl_INST_gameControl = 0;
	static final int Ghost_INST_ghost = 1;
	static final int Player_INST_player = 2;
	static final int GameModel_INST_gameModel = 3;


	MSDAspectPacmanEatsGhost()
	{
		addMinimalEvent(MSDMethods.GameControl_Ghost_collidedWithPacman);
		setHotCut(2,6,2,1);
		setHotCut(2,5,2,0);
		setHotCut(2,3,2,0);
		setHotCut(1,2,0,0);
		setHotCut(2,8,2,1);
		setHotCut(1,1,0,0);
		setHotCut(2,2,1,0);
		setLastCut(2,9,2,2);
		numberOfLifeLines = 4;
		numberOfInstances = 4;
		numberOfVariables = 0;
	}

	//Pointcuts and advices:
	pointcut Ghost_GameModel_enteringJail(Ghost ghost, GameModel gameModel):
		call(void GameModel.enteringJail(..))
		&& target(gameModel) && this(ghost) ;

	after(Ghost ghost,GameModel gameModel):Ghost_GameModel_enteringJail(ghost,gameModel)
	{
		changeCutState(MSDMethods.Ghost_GameModel_enteringJail,
					ghost,gameModel,null);
	}

	pointcut Ghost_GameModel_leavingJail(Ghost ghost, GameModel gameModel):
		call(void GameModel.leavingJail(..))
		&& target(gameModel) && this(ghost) ;

	after(Ghost ghost,GameModel gameModel):Ghost_GameModel_leavingJail(ghost,gameModel)
	{
		changeCutState(MSDMethods.Ghost_GameModel_leavingJail,
					ghost,gameModel,null);
	}

	pointcut GameControl_Ghost_collidedWithPacman(GameControl gameControl, Ghost ghost):
		call(void Ghost.collidedWithPacman(..))
		&& target(ghost) && this(gameControl) ;

	after(GameControl gameControl,Ghost ghost):GameControl_Ghost_collidedWithPacman(gameControl,ghost)
	{
		changeCutState(MSDMethods.GameControl_Ghost_collidedWithPacman,
					gameControl,ghost,null);
	}

	pointcut GameControl_Player_eatGhost(GameControl gameControl, Player player):
		call(void Player.eatGhost(..))
		&& target(player) && this(gameControl) ;

	after(GameControl gameControl,Player player):GameControl_Player_eatGhost(gameControl,player)
	{
		changeCutState(MSDMethods.GameControl_Player_eatGhost,
					gameControl,player,null);
	}

	pointcut Ghost_Ghost_leaveJail(Ghost ghost):
		execution(void Ghost.leaveJail(..))
		&& target(ghost) ;

	after(Ghost ghost):Ghost_Ghost_leaveJail(ghost)
	{
		changeCutState(MSDMethods.Ghost_Ghost_leaveJail,
					ghost,ghost,null);
	}

	pointcut Ghost_Ghost_goToJail(Ghost ghost):
		execution(void Ghost.goToJail(..))
		&& target(ghost) ;

	after(Ghost ghost):Ghost_Ghost_goToJail(ghost)
	{
		changeCutState(MSDMethods.Ghost_Ghost_goToJail,
					ghost,ghost,null);
	}

	pointcut Player_Ghost_eatenByPacman(Player player, Ghost ghost):
		call(void Ghost.eatenByPacman(..))
		&& target(ghost) && this(player) ;

	after(Player player,Ghost ghost):Player_Ghost_eatenByPacman(player,ghost)
	{
		changeCutState(MSDMethods.Player_Ghost_eatenByPacman,
					player,ghost,null);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.Ghost_GameModel_enteringJail:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,null))
				{
					unification=true;
					if(activeMSD.isInCut(2,5,2,0))
					{
						activeMSD.setLineInstance(GameModel_INST_gameModel,targetObject);
						activeMSD.setCut(2,6,2,1);
						if(evaluateCondition(1,activeMSD))
						{
							activeMSD.setCut(2,7,2,1);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_GameModel_leavingJail:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,8,2,1))
					{
						activeMSD.setCut(2,9,2,2);
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_Ghost_collidedWithPacman:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,null)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,0,0))
					{
						activeMSD.setLineInstance(Ghost_INST_ghost,targetObject);
						activeMSD.setLineInstance(GameControl_INST_gameControl,sourceObject);
						activeMSD.setCut(1,1,0,0);
						if(evaluateCondition(4,activeMSD))
						{
							activeMSD.setCut(1,2,0,0);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_Player_eatGhost:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,null))
				{
					unification=true;
					if(activeMSD.isInCut(1,2,0,0))
					{
						activeMSD.setLineInstance(Player_INST_player,targetObject);
						activeMSD.setCut(2,2,1,0);
						return;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Ghost_leaveJail:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,7,2,1))
					{
						activeMSD.setCut(2,8,2,1);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Ghost_goToJail:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,4,2,0))
					{
						activeMSD.setCut(2,5,2,0);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Player_Ghost_eatenByPacman:
				if(activeMSD.instancesEquals(Player_INST_player,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,2,1,0))
					{
						activeMSD.setCut(2,3,2,0);
						if(evaluateCondition(9,activeMSD))
						{
							activeMSD.setCut(2,4,2,0);
							return;
						}
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);

		switch (conditionNumber)
		{
			case 1: 
				return ghost.state==Ghost.JAIL;
			case 4: 
				return ghost.isEaten();
			case 9: 
				return ghost.state==Ghost.EATEN;
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);

		MSDMethod MSDm0 = new MSDMethod(gameControl,ghost,
			MSDMethods.GameControl_Ghost_collidedWithPacman,null);// collidedWithPacman() Monitored
		MSDMethod MSDm1 = new MSDMethod(ghost,gameModel,
			MSDMethods.Ghost_GameModel_leavingJail,null);// leavingJail() Monitored
		MSDMethod MSDm2 = new MSDMethod(player,ghost,
			MSDMethods.Player_Ghost_eatenByPacman,null);// eatenByPacman() Monitored
		MSDMethod MSDm3 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_leaveJail,null);// leaveJail() Monitored
		MSDMethod MSDm4 = new MSDMethod(ghost,gameModel,
			MSDMethods.Ghost_GameModel_enteringJail,null);// enteringJail() Monitored
		MSDMethod MSDm5 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_goToJail,null);// goToJail() Monitored
		MSDMethod MSDm6 = new MSDMethod(gameControl,player,
			MSDMethods.GameControl_Player_eatGhost,null);// eatGhost() Monitored

		 if(activeMSD.isInCut(0,0,0,0))
		{
				ME.add(MSDm0);
				CV.add(MSDm5,MSDm3,MSDm4,MSDm1,MSDm6,MSDm2);
				return;
		}
		 if(activeMSD.isInCut(1,2,0,0))
		{
				ME.add(MSDm6);
				HV.add(MSDm5,MSDm3,MSDm4,MSDm1,MSDm0,MSDm2);
				return;
		}
		 if(activeMSD.isInCut(2,2,1,0))
		{
				ME.add(MSDm2);
				HV.add(MSDm5,MSDm3,MSDm4,MSDm1,MSDm0,MSDm6);
				return;
		}
		 if(activeMSD.isInCut(2,4,2,0))
		{
				ME.add(MSDm5);
				CV.add(MSDm3,MSDm4,MSDm1,MSDm0,MSDm6,MSDm2);
				return;
		}
		 if(activeMSD.isInCut(2,5,2,0))
		{
				ME.add(MSDm4);
				HV.add(MSDm5,MSDm3,MSDm1,MSDm0,MSDm6,MSDm2);
				return;
		}
		 if(activeMSD.isInCut(2,7,2,1))
		{
				ME.add(MSDm3);
				CV.add(MSDm5,MSDm4,MSDm1,MSDm0,MSDm6,MSDm2);
				return;
		}
		 if(activeMSD.isInCut(2,8,2,1))
		{
				ME.add(MSDm1);
				HV.add(MSDm5,MSDm3,MSDm4,MSDm0,MSDm6,MSDm2);
				return;
		}
	}
}
