//  The file MSDAspectFlipUp.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package il.ac.wis.cs.s2a.examples.memoryGame.aspects;

import il.ac.wis.cs.s2a.examples.memoryGame.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectFlipUp extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int MemoryCard_INST_mc1 = 0;
	static final int MemoryPanel_INST_memoryPanel = 1;


	MSDAspectFlipUp()
	{
		addMinimalEvent(MSDMethods.env_MemoryCard_mouseClicked);
		setHotCut(1,3,1);
		setHotCut(1,2,0);
		setLastCut(1,4,1);
		numberOfLifeLines = 3;
		numberOfInstances = 2;
		numberOfVariables = 0;
	}

	//Pointcuts and advices:
	pointcut MemoryCard_MemoryCard_reDraw(MemoryCard memoryCard):
		execution(void MemoryCard.reDraw(..))
		&& target(memoryCard) ;

	after(MemoryCard memoryCard):MemoryCard_MemoryCard_reDraw(memoryCard)
	{
		changeCutState(MSDMethods.MemoryCard_MemoryCard_reDraw,
					memoryCard,memoryCard,null);
	}

	pointcut env_MemoryCard_mouseClicked(MemoryCard memoryCard):
		execution(void MemoryCard.mouseClicked(..))
		&& target(memoryCard) ;

	after(MemoryCard memoryCard):env_MemoryCard_mouseClicked(memoryCard)
	{
		changeCutState(MSDMethods.env_MemoryCard_mouseClicked,
					null,memoryCard,null);
	}

	pointcut MemoryPanel_MemoryCard_flipUp(MemoryPanel memoryPanel, MemoryCard memoryCard):
		call(void MemoryCard.flipUp(..))
		&& target(memoryCard) && this(memoryPanel) ;

	after(MemoryPanel memoryPanel,MemoryCard memoryCard):MemoryPanel_MemoryCard_flipUp(memoryPanel,memoryCard)
	{
		changeCutState(MSDMethods.MemoryPanel_MemoryCard_flipUp,
					memoryPanel,memoryCard,null);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.MemoryCard_MemoryCard_reDraw:
				if(activeMSD.instancesEquals(MemoryCard_INST_mc1,sourceObject)
					&& activeMSD.instancesEquals(MemoryCard_INST_mc1,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,3,1))
					{
						activeMSD.setCut(1,4,1);
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.env_MemoryCard_mouseClicked:
				if(activeMSD.instancesEquals(MemoryCard_INST_mc1,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,0))
					{
						activeMSD.setLineInstance(MemoryCard_INST_mc1,targetObject);
						activeMSD.setCut(1,1,0);
						if(evaluateCondition(2,activeMSD))
						{
							activeMSD.setCut(1,2,0);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(MemoryCard_INST_mc1,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.MemoryPanel_MemoryCard_flipUp:
				if(activeMSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMSD.instancesEquals(MemoryCard_INST_mc1,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,2,0))
					{
						activeMSD.setCut(1,3,1);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		MemoryCard mc1 = (MemoryCard)activeMSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryPanel memoryPanel = (MemoryPanel)activeMSD.getLineInstance(MemoryPanel_INST_memoryPanel);

		switch (conditionNumber)
		{
			case 2: 
				return !mc1.faceUp;
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		activeMSD.setLineInstance(MemoryPanel_INST_memoryPanel,MSDEnv.getLifeLineInstance("MemoryPanel"));
		MemoryCard mc1 = (MemoryCard)activeMSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryPanel memoryPanel = (MemoryPanel)activeMSD.getLineInstance(MemoryPanel_INST_memoryPanel);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		MemoryCard mc1 = (MemoryCard)activeMSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryPanel memoryPanel = (MemoryPanel)activeMSD.getLineInstance(MemoryPanel_INST_memoryPanel);

		MSDMethod MSDm0 = new MSDMethod(memoryPanel,mc1,
			MSDMethods.MemoryPanel_MemoryCard_flipUp,null);// flipUp() Execute
		MSDMethod MSDm1 = new MSDMethod(mc1,mc1,
			MSDMethods.MemoryCard_MemoryCard_reDraw,null);// reDraw() Execute
		MSDMethod MSDm2 = new MSDMethod(null,mc1,
			MSDMethods.env_MemoryCard_mouseClicked,null);// mouseClicked() Monitored

		 if(activeMSD.isInCut(0,0,0))
		{
				ME.add(MSDm2);
				CV.add(MSDm1,MSDm0);
				return;
		}
		 if(activeMSD.isInCut(1,2,0))
		{
				EE.add(MSDm0);
				HV.add(MSDm1,MSDm2);
				return;
		}
		 if(activeMSD.isInCut(1,3,1))
		{
				EE.add(MSDm1);
				HV.add(MSDm0,MSDm2);
				return;
		}
	}
}
