//  The file MSDAspectGhostStopsFleeing.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package pacman.aspects;

import pacman.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectGhostStopsFleeing extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int GameControl_INST_gameControl = 0;
	static final int Ghost_INST_ghost = 1;

	static final int boolean_arg_exact_shape0 = 0;

	MSDAspectGhostStopsFleeing()
	{
		addMinimalEvent(MSDMethods.Ghost_Ghost_slowDown);
		setHotCut(0,1);
		setHotCut(1,3);
		setHotCut(1,4);
		setHotCut(2,5);
		setLastCut(2,6);
		numberOfLifeLines = 2;
		numberOfInstances = 2;
		numberOfVariables = 1;
	}

	//Pointcuts and advices:
	pointcut Ghost_GameControl_ghostSlowedDown(Ghost ghost, GameControl gameControl):
		call(void GameControl.ghostSlowedDown(..))
		&& target(gameControl) && this(ghost) ;

	after(Ghost ghost,GameControl gameControl):Ghost_GameControl_ghostSlowedDown(ghost,gameControl)
	{
		changeCutState(MSDMethods.Ghost_GameControl_ghostSlowedDown,
					ghost,gameControl,null);
	}

	pointcut Ghost_Ghost_speedUp(Ghost ghost):
		execution(void Ghost.speedUp(..))
		&& target(ghost) ;

	after(Ghost ghost):Ghost_Ghost_speedUp(ghost)
	{
		changeCutState(MSDMethods.Ghost_Ghost_speedUp,
					ghost,ghost,null);
	}

	pointcut Ghost_Ghost_stopFleeing(Ghost ghost):
		execution(void Ghost.stopFleeing(..))
		&& target(ghost) ;

	after(Ghost ghost):Ghost_Ghost_stopFleeing(ghost)
	{
		changeCutState(MSDMethods.Ghost_Ghost_stopFleeing,
					ghost,ghost,null);
	}

	pointcut Ghost_Ghost_slowDown(Ghost ghost):
		execution(void Ghost.slowDown(..))
		&& target(ghost) ;

	after(Ghost ghost):Ghost_Ghost_slowDown(ghost)
	{
		changeCutState(MSDMethods.Ghost_Ghost_slowDown,
					ghost,ghost,null);
	}

	pointcut Ghost_GameControl_ghostStoppedFleeing(Ghost ghost, GameControl gameControl):
		call(void GameControl.ghostStoppedFleeing(..))
		&& target(gameControl) && this(ghost) ;

	after(Ghost ghost,GameControl gameControl):Ghost_GameControl_ghostStoppedFleeing(ghost,gameControl)
	{
		changeCutState(MSDMethods.Ghost_GameControl_ghostStoppedFleeing,
					ghost,gameControl,null);
	}

	pointcut Ghost_Ghost_setNormalShape(Ghost ghost,boolean exact_shape0):
		execution(void Ghost.setNormalShape(..))
		&& target(ghost)  && args(exact_shape0);

	after(Ghost ghost,boolean exact_shape0):Ghost_Ghost_setNormalShape(ghost, exact_shape0)
	{
		ArrayList<Object> args = getArgsList(exact_shape0);
		changeCutState(MSDMethods.Ghost_Ghost_setNormalShape,
					ghost,ghost,args);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.Ghost_GameControl_ghostSlowedDown:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,1))
					{
						activeMSD.setLineInstance(GameControl_INST_gameControl,targetObject);
						activeMSD.setCut(1,2);
						return;
					}
				}
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Ghost_speedUp:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,3))
					{
						activeMSD.setCut(1,4);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Ghost_stopFleeing:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,2))
					{
						activeMSD.setCut(1,3);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Ghost_slowDown:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,null)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0))
					{
						activeMSD.setLineInstance(Ghost_INST_ghost,targetObject);
						activeMSD.setCut(0,1);
						return;
					}
				}
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_GameControl_ghostStoppedFleeing:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,4))
					{
						activeMSD.setCut(2,5);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Ghost_Ghost_setNormalShape:
				if(activeMSD.instancesEquals(Ghost_INST_ghost,sourceObject)
					&& activeMSD.instancesEquals(Ghost_INST_ghost,targetObject)
					&& activeMSD.variableEquals(boolean_arg_exact_shape0,args.get(0)))
				{
					unification=true;
					if(activeMSD.isInCut(2,5))
					{
						activeMSD.setCut(2,6);
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		Boolean shape0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_shape0);

		switch (conditionNumber)
		{
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		activeMSD.setPrivateVariable(boolean_arg_exact_shape0,true);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		Boolean shape0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_shape0);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Ghost ghost = (Ghost)activeMSD.getLineInstance(Ghost_INST_ghost);
		Boolean VAR_exact_shape0 = (Boolean) activeMSD.getPrivateVariable(boolean_arg_exact_shape0);

		MSDMethod MSDm53 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_speedUp,null);// speedUp() Monitored
		MSDMethod MSDm54 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_slowDown,null);// slowDown() Monitored
		MSDMethod MSDm55 = new MSDMethod(ghost,gameControl,
			MSDMethods.Ghost_GameControl_ghostStoppedFleeing,null);// ghostStoppedFleeing() Monitored
		MSDMethod MSDm56 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_stopFleeing,null);// stopFleeing() Monitored
		ArrayList<Object>  args57 = getArgsList(VAR_exact_shape0);
		MSDMethod MSDm57 = new MSDMethod(ghost,ghost,
			MSDMethods.Ghost_Ghost_setNormalShape,args57);// setNormalShape() Monitored
		MSDMethod MSDm58 = new MSDMethod(ghost,gameControl,
			MSDMethods.Ghost_GameControl_ghostSlowedDown,null);// ghostSlowedDown() Monitored

		 if(activeMSD.isInCut(0,0))
		{
				ME.add(MSDm54);
				CV.add(MSDm55,MSDm53,MSDm57,MSDm56,MSDm58);
				return;
		}
		 if(activeMSD.isInCut(0,1))
		{
				ME.add(MSDm58);
				HV.add(MSDm55,MSDm53,MSDm54,MSDm57,MSDm56);
				return;
		}
		 if(activeMSD.isInCut(1,2))
		{
				ME.add(MSDm56);
				CV.add(MSDm55,MSDm53,MSDm54,MSDm57,MSDm58);
				return;
		}
		 if(activeMSD.isInCut(1,3))
		{
				ME.add(MSDm53);
				HV.add(MSDm55,MSDm54,MSDm57,MSDm56,MSDm58);
				return;
		}
		 if(activeMSD.isInCut(1,4))
		{
				ME.add(MSDm55);
				HV.add(MSDm53,MSDm54,MSDm57,MSDm56,MSDm58);
				return;
		}
		 if(activeMSD.isInCut(2,5))
		{
				ME.add(MSDm57);
				HV.add(MSDm55,MSDm53,MSDm54,MSDm56,MSDm58);
				return;
		}
	}
}
