//  The file MSDAspectHighScoresUpdate.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package pacman.aspects;

import pacman.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectHighScoresUpdate extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int GameControl_INST_gameControl = 0;
	static final int GameModel_INST_gameModel = 1;
	static final int Player_INST_player = 2;

	static final int int_arg_symbolic_score = 0;

	MSDAspectHighScoresUpdate()
	{
		addMinimalEvent(MSDMethods.GameControl_GameModel_gameOver);
		setHotCut(2,4,3);
		setHotCut(1,1,0);
		setHotCut(2,2,1);
		setLastCut(2,5,4);
		numberOfLifeLines = 3;
		numberOfInstances = 3;
		numberOfVariables = 1;
	}

	//Pointcuts and advices:
	pointcut Player_GameModel_setHighScore(Player player, GameModel gameModel,Object symbolic_score):
		call(void GameModel.setHighScore(..))
		&& target(gameModel) && this(player)  && args(symbolic_score);

	after(Player player,GameModel gameModel,Object symbolic_score):Player_GameModel_setHighScore(player,gameModel, symbolic_score)
	{
		ArrayList<Object> args = getArgsList(symbolic_score);
		changeCutState(MSDMethods.Player_GameModel_setHighScore,
					player,gameModel,args);
	}

	pointcut GameControl_GameModel_gameOver(GameControl gameControl, GameModel gameModel):
		call(void GameModel.gameOver(..))
		&& target(gameModel) && this(gameControl) ;

	after(GameControl gameControl,GameModel gameModel):GameControl_GameModel_gameOver(gameControl,gameModel)
	{
		changeCutState(MSDMethods.GameControl_GameModel_gameOver,
					gameControl,gameModel,null);
	}

	pointcut Player_GameModel_getHighScore(Player player, GameModel gameModel):
		call(int GameModel.getHighScore(..))
		&& target(gameModel) && this(player) ;

	after(Player player,GameModel gameModel):Player_GameModel_getHighScore(player,gameModel)
	{
		changeCutState(MSDMethods.Player_GameModel_getHighScore,
					player,gameModel,null);
	}

	pointcut GameControl_Player_checkHighScore(GameControl gameControl, Player player):
		call(void Player.checkHighScore(..))
		&& target(player) && this(gameControl) ;

	after(GameControl gameControl,Player player):GameControl_Player_checkHighScore(gameControl,player)
	{
		changeCutState(MSDMethods.GameControl_Player_checkHighScore,
					gameControl,player,null);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.Player_GameModel_setHighScore:
				if(activeMSD.instancesEquals(Player_INST_player,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,4,3))
					{
						activeMSD.setPrivateVariable(int_arg_symbolic_score,args.get(0));
						activeMSD.setCut(2,5,4);
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_GameModel_gameOver:
				if(activeMSD.instancesEquals(GameModel_INST_gameModel,null)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,0))
					{
						activeMSD.setLineInstance(GameModel_INST_gameModel,targetObject);
						activeMSD.setLineInstance(GameControl_INST_gameControl,sourceObject);
						activeMSD.setCut(1,1,0);
						if(evaluateCondition(2,activeMSD))
						{
							activeMSD.setCut(1,2,0);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Player_GameModel_getHighScore:
				if(activeMSD.instancesEquals(Player_INST_player,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,2,1))
					{
						activeMSD.setCut(2,3,2);
						if(evaluateCondition(4,activeMSD))
						{
							activeMSD.setCut(2,4,3);
							return;
						}
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_Player_checkHighScore:
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,null))
				{
					unification=true;
					if(activeMSD.isInCut(1,2,0))
					{
						activeMSD.setLineInstance(Player_INST_player,targetObject);
						activeMSD.setCut(2,2,1);
						return;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		Integer score = (Integer) activeMSD.getPrivateVariable(int_arg_symbolic_score);

		switch (conditionNumber)
		{
			case 2: 
				return gameModel.m_state == GameModel.STATE_GAMEOVER;
			case 4: 
				return player.m_score > gameModel.m_highScore;
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		Integer score = (Integer) activeMSD.getPrivateVariable(int_arg_symbolic_score);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		Integer VAR_symbolic_score = (Integer) activeMSD.getPrivateVariable(int_arg_symbolic_score);

		MSDMethod MSDm29 = new MSDMethod(player,gameModel,
			MSDMethods.Player_GameModel_getHighScore,null);// getHighScore() Monitored
		ArrayList<Object>  args30 = getArgsList(VAR_symbolic_score);
		MSDMethod MSDm30 = new MSDMethod(player,gameModel,
			MSDMethods.Player_GameModel_setHighScore,args30);// setHighScore() Monitored
		MSDMethod MSDm31 = new MSDMethod(gameControl,player,
			MSDMethods.GameControl_Player_checkHighScore,null);// checkHighScore() Monitored
		MSDMethod MSDm32 = new MSDMethod(gameControl,gameModel,
			MSDMethods.GameControl_GameModel_gameOver,null);// gameOver() Monitored

		 if(activeMSD.isInCut(0,0,0))
		{
				ME.add(MSDm32);
				CV.add(MSDm30,MSDm29,MSDm31);
				return;
		}
		 if(activeMSD.isInCut(1,2,0))
		{
				ME.add(MSDm31);
				CV.add(MSDm32,MSDm30,MSDm29);
				return;
		}
		 if(activeMSD.isInCut(2,2,1))
		{
				ME.add(MSDm29);
				HV.add(MSDm32,MSDm30,MSDm31);
				return;
		}
		 if(activeMSD.isInCut(2,4,3))
		{
				ME.add(MSDm30);
				HV.add(MSDm32,MSDm29,MSDm31);
				return;
		}
	}
}
