//  The file MSDAspectPacmanEatsFruit.aj was automatically generated using S2A 0.6 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.6 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package pacman.aspects;

import pacman.classes.*;
import java.util.ArrayList;
import il.ac.wis.cs.s2a.runtime.lib.*;


public aspect MSDAspectPacmanEatsFruit extends MSDAspect
{


	//Constants for instances, locations and varaibles
	static final int Player_INST_player = 0;
	static final int GameControl_INST_gameControl = 1;
	static final int Fruit_INST_fruit = 2;
	static final int GameModel_INST_gameModel = 3;


	MSDAspectPacmanEatsFruit()
	{
		addMinimalEvent(MSDMethods.GameControl_Player_eatFruit);
		addMinimalEvent(MSDMethods.Fruit_Fruit_enterScreen);
		setHotCut(3,2,4,0);
		setHotCut(2,1,5,1);
		setHotCut(3,2,5,1);
		setHotCut(0,0,1,0);
		setHotCut(2,1,4,0);
		setHotCut(2,1,3,0);
		setHotCut(2,1,6,1);
		setHotCut(1,1,2,0);
		setHotCut(3,2,6,1);
		setHotCut(1,1,1,0);
		setLastCut(4,2,7,1);
		numberOfLifeLines = 4;
		numberOfInstances = 4;
		numberOfVariables = 0;
	}

	//Pointcuts and advices:
	pointcut Fruit_Player_increaseScore(Fruit fruit, Player player):
		call(void Player.increaseScore(..))
		&& target(player) && this(fruit) ;

	after(Fruit fruit,Player player):Fruit_Player_increaseScore(fruit,player)
	{
		changeCutState(MSDMethods.Fruit_Player_increaseScore,
					fruit,player,null);
	}

	pointcut Player_GameControl_fruitEaten(Player player, GameControl gameControl):
		call(void GameControl.fruitEaten(..))
		&& target(gameControl) && this(player) ;

	after(Player player,GameControl gameControl):Player_GameControl_fruitEaten(player,gameControl)
	{
		changeCutState(MSDMethods.Player_GameControl_fruitEaten,
					player,gameControl,null);
	}

	pointcut GameControl_Player_eatFruit(GameControl gameControl, Player player):
		call(void Player.eatFruit(..))
		&& target(player) && this(gameControl) ;

	after(GameControl gameControl,Player player):GameControl_Player_eatFruit(gameControl,player)
	{
		changeCutState(MSDMethods.GameControl_Player_eatFruit,
					gameControl,player,null);
	}

	pointcut Fruit_Fruit_enterScreen(Fruit fruit):
		execution(void Fruit.enterScreen(..))
		&& target(fruit) ;

	after(Fruit fruit):Fruit_Fruit_enterScreen(fruit)
	{
		changeCutState(MSDMethods.Fruit_Fruit_enterScreen,
					fruit,fruit,null);
	}

	pointcut Fruit_GameModel_getFruitScore(Fruit fruit, GameModel gameModel):
		call(int GameModel.getFruitScore(..))
		&& target(gameModel) && this(fruit) ;

	after(Fruit fruit,GameModel gameModel):Fruit_GameModel_getFruitScore(fruit,gameModel)
	{
		changeCutState(MSDMethods.Fruit_GameModel_getFruitScore,
					fruit,gameModel,null);
	}

	pointcut Player_Fruit_eatenByPacman(Player player, Fruit fruit):
		call(void Fruit.eatenByPacman(..))
		&& target(fruit) && this(player) ;

	after(Player player,Fruit fruit):Player_Fruit_eatenByPacman(player,fruit)
	{
		changeCutState(MSDMethods.Player_Fruit_eatenByPacman,
					player,fruit,null);
	}

	// MSD Logic:
	protected void  changeActiveMSDCutState(int MSDm, Object sourceObject, Object targetObject,ActiveMSDAspect activeMSD,
		ArrayList args)
	{

		boolean unification=false;
		switch (MSDm)
		{
			case MSDMethods.Fruit_Player_increaseScore:
				if(activeMSD.instancesEquals(Fruit_INST_fruit,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(3,2,6,1))
					{
						activeMSD.setCut(4,2,7,1);
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Player_GameControl_fruitEaten:
				if(activeMSD.instancesEquals(Player_INST_player,sourceObject)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,1,4,0))
					{
						activeMSD.setCut(3,2,4,0);
						return;
					}
				}
				if(activeMSD.instancesEquals(Player_INST_player,sourceObject)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(2,1,6,1))
					{
						activeMSD.setCut(3,2,6,1);
						return;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.GameControl_Player_eatFruit:
				if(activeMSD.instancesEquals(Player_INST_player,null)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,0,0))
					{
						activeMSD.setLineInstance(Player_INST_player,targetObject);
						activeMSD.setLineInstance(GameControl_INST_gameControl,sourceObject);
						activeMSD.setCut(1,1,0,0);
						return;
					}
				}
				if(activeMSD.instancesEquals(Player_INST_player,null)
					&& activeMSD.instancesEquals(GameControl_INST_gameControl,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,2,0))
					{
						activeMSD.setLineInstance(Player_INST_player,targetObject);
						activeMSD.setLineInstance(GameControl_INST_gameControl,sourceObject);
						activeMSD.setCut(1,1,2,0);
						return;
					}
				}
				if(activeMSD.instancesEquals(GameControl_INST_gameControl,sourceObject)
					&& activeMSD.instancesEquals(Player_INST_player,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Fruit_Fruit_enterScreen:
				if(activeMSD.instancesEquals(Fruit_INST_fruit,null)
					&& activeMSD.instancesEquals(Fruit_INST_fruit,null))
				{
					unification=true;
					if(activeMSD.isInCut(1,1,0,0))
					{
						activeMSD.setLineInstance(Fruit_INST_fruit,targetObject);
						activeMSD.setCut(1,1,1,0);
						if(evaluateCondition(6,activeMSD))
						{
							activeMSD.setCut(1,1,2,0);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(Fruit_INST_fruit,null)
					&& activeMSD.instancesEquals(Fruit_INST_fruit,null))
				{
					unification=true;
					if(activeMSD.isInCut(0,0,0,0))
					{
						activeMSD.setLineInstance(Fruit_INST_fruit,targetObject);
						activeMSD.setCut(0,0,1,0);
						if(evaluateCondition(6,activeMSD))
						{
							activeMSD.setCut(0,0,2,0);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(Fruit_INST_fruit,sourceObject)
					&& activeMSD.instancesEquals(Fruit_INST_fruit,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Fruit_GameModel_getFruitScore:
				if(activeMSD.instancesEquals(Fruit_INST_fruit,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,null))
				{
					unification=true;
					if(activeMSD.isInCut(3,2,4,0))
					{
						activeMSD.setLineInstance(GameModel_INST_gameModel,targetObject);
						activeMSD.setCut(3,2,5,1);
						if(evaluateCondition(10,activeMSD))
						{
							activeMSD.setCut(3,2,6,1);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(Fruit_INST_fruit,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,null))
				{
					unification=true;
					if(activeMSD.isInCut(2,1,4,0))
					{
						activeMSD.setLineInstance(GameModel_INST_gameModel,targetObject);
						activeMSD.setCut(2,1,5,1);
						if(evaluateCondition(10,activeMSD))
						{
							activeMSD.setCut(2,1,6,1);
							return;
						}
						break;
					}
				}
				if(activeMSD.instancesEquals(Fruit_INST_fruit,sourceObject)
					&& activeMSD.instancesEquals(GameModel_INST_gameModel,targetObject))
				{
					unification=true;
				}
				if(!unification)//No unification...
					return;
				break;

			case MSDMethods.Player_Fruit_eatenByPacman:
				if(activeMSD.instancesEquals(Player_INST_player,sourceObject)
					&& activeMSD.instancesEquals(Fruit_INST_fruit,targetObject))
				{
					unification=true;
					if(activeMSD.isInCut(1,1,2,0))
					{
						activeMSD.setCut(2,1,3,0);
						if(evaluateCondition(14,activeMSD))
						{
							activeMSD.setCut(2,1,4,0);
							return;
						}
						break;
					}
				}
				if(!unification)//No unification...
					return;
				break;

			}
		if(activeMSD.checkViolation())
			activeMSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMSDAspect activeMSD)
	{
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Fruit fruit = (Fruit)activeMSD.getLineInstance(Fruit_INST_fruit);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);

		switch (conditionNumber)
		{
			case 6: 
				return fruit.m_bVisible == true;
			case 10: 
				return fruit.score <= 7500;
			case 14: 
				return fruit.m_bVisible == false;
		}
		return false;
	}


	@SuppressWarnings("unused")
	protected void doBindings(ActiveMSDAspect activeMSD)
	{
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Fruit fruit = (Fruit)activeMSD.getLineInstance(Fruit_INST_fruit);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);

	}

	protected void getActiveMSDCutState(MSDMethodSet ME,MSDMethodSet EE,
			MSDMethodSet CV,MSDMethodSet HV,ActiveMSDAspect activeMSD)
	{
		Player player = (Player)activeMSD.getLineInstance(Player_INST_player);
		GameControl gameControl = (GameControl)activeMSD.getLineInstance(GameControl_INST_gameControl);
		Fruit fruit = (Fruit)activeMSD.getLineInstance(Fruit_INST_fruit);
		GameModel gameModel = (GameModel)activeMSD.getLineInstance(GameModel_INST_gameModel);

		MSDMethod MSDm15 = new MSDMethod(fruit,fruit,
			MSDMethods.Fruit_Fruit_enterScreen,null);// enterScreen() Monitored
		MSDMethod MSDm17 = new MSDMethod(player,gameControl,
			MSDMethods.Player_GameControl_fruitEaten,null);// fruitEaten() Monitored
		MSDMethod MSDm19 = new MSDMethod(player,fruit,
			MSDMethods.Player_Fruit_eatenByPacman,null);// eatenByPacman() Monitored
		MSDMethod MSDm20 = new MSDMethod(fruit,player,
			MSDMethods.Fruit_Player_increaseScore,null);// increaseScore() Monitored
		MSDMethod MSDm21 = new MSDMethod(fruit,gameModel,
			MSDMethods.Fruit_GameModel_getFruitScore,null);// getFruitScore() Monitored
		MSDMethod MSDm23 = new MSDMethod(gameControl,player,
			MSDMethods.GameControl_Player_eatFruit,null);// eatFruit() Monitored

		 if(activeMSD.isInCut(0,0,0,0))
		{
				ME.add(MSDm23);
				ME.add(MSDm15);
				CV.add(MSDm20,MSDm17,MSDm21,MSDm19);
				return;
		}
		 if(activeMSD.isInCut(1,1,0,0))
		{
				ME.add(MSDm15);
				CV.add(MSDm20,MSDm17,MSDm23,MSDm21,MSDm19);
				return;
		}
		 if(activeMSD.isInCut(0,0,2,0))
		{
				ME.add(MSDm23);
				CV.add(MSDm20,MSDm17,MSDm21,MSDm15,MSDm19);
				return;
		}
		 if(activeMSD.isInCut(1,1,2,0))
		{
				ME.add(MSDm19);
				HV.add(MSDm20,MSDm17,MSDm23,MSDm21,MSDm15);
				return;
		}
		 if(activeMSD.isInCut(2,1,4,0))
		{
				ME.add(MSDm17);
				ME.add(MSDm21);
				HV.add(MSDm20,MSDm23,MSDm15,MSDm19);
				return;
		}
		 if(activeMSD.isInCut(3,2,4,0))
		{
				ME.add(MSDm21);
				HV.add(MSDm20,MSDm17,MSDm23,MSDm15,MSDm19);
				return;
		}
		 if(activeMSD.isInCut(2,1,6,1))
		{
				ME.add(MSDm17);
				HV.add(MSDm20,MSDm23,MSDm21,MSDm15,MSDm19);
				return;
		}
		 if(activeMSD.isInCut(3,2,6,1))
		{
				ME.add(MSDm20);
				HV.add(MSDm17,MSDm23,MSDm21,MSDm15,MSDm19);
				return;
		}
	}
}
